(*
    #######################################################

    ړI    :   Shell̃hbOAhhbv󂯕t
        :   2003/09/20 쐬
                2004/04/07 JnE~R}V

    gp  :   var
                    Dropper: TShellDrop;

                procedure   TForm1.DroppedAction(AFiles, AFolds: TStringList;
                            AControl: TControl; APos: TPoint);
                begin
                    Memo1.Clear;
                    Memo1.Lines.Add(StringOfChar('=', 50));
                    Memo1.Lines.Add(AControl.Name);
                    Memo1.Lines.Add(StringOfChar('=', 50));
                    Memo1.Lines.Add(Format('X%3d:Y%3d', [APos.X, APos.Y]));
                    Memo1.Lines.Add(StringOfChar('=', 50));
                    Memo1.Lines.AddStrings(AFiles);
                    Memo1.Lines.Add(StringOfChar('=', 50));
                    Memo1.Lines.AddStrings(AFolds);
                    Memo1.Lines.Add(StringOfChar('=', 50));
                end;

                procedure TForm1.FormCreate(Sender: TObject);
                begin
                    Dropper := TShellDrop.Create(Memo1, DroppedAction);
                    Dropper.Start();
                end;

                procedure TForm1.FormDestroy(Sender: TObject);
                begin
                    Dropper.Free;
                end;

    Ql:   http://www.psn.ne.jp/~nagayama/program/0017.html


    #######################################################
*)

unit iDragDrop;

interface

uses
    Windows, Messages, Classes, Controls;

type
    TOnShellDropped = procedure(AFiles, AFolds: TStringList;
                                AControl: TControl; APos: TPoint) of object;
//    TOnShellDropped = procedure(AFiles, AFolds: TStringList;
//                                AControl: TControl; APos: TPoint);


    TShellDrop = class
    private
        FTarget     : TWinControl;

        FOldWndProc : Pointer;
        FNewWndProc : Pointer;
        FWndHandle  : HWND;
        FEnabled    : Boolean;

        DropFileList: TStringList;
        DropFoldList: TStringList;
        DropPos     : TPoint;
        DropControl : TControl;

        FOnDropped  : TOnShellDropped;

        procedure   WndProc(var Msg: TMessage); virtual;
        procedure   UpdateDropList(AFileName: string);
    public
        constructor Create(ATarget: TWinControl; AOnDropped: TOnShellDropped);
        destructor  Destroy; override;
        procedure   Start();
        procedure   Stop();
    published

    end;

implementation

uses
    ShellApi, SysUtils, Forms;


//------------------------------------------------------------------------------
(* hbvt@CXgXV *)
procedure   TShellDrop.UpdateDropList(AFileName: string);
begin
    // tH_H
    if DirectoryExists(AFileName) then
    begin
        DropFoldList.Add(AFileName);
    end else
    // t@CH
    if FileExists(AFileName) then
    begin
        DropFileList.Add(AFileName);
    end else
    // ꂾ܂H
    begin
        ;
    end;
end;

//------------------------------------------------------------------------------
(* RXgN^ *)
constructor TShellDrop.Create(ATarget: TWinControl; AOnDropped: TOnShellDropped);
begin
    // ̂ƂRg[ۑ
    FTarget := ATarget;
    // ̃nhۑ
    FWndHandle  := FTarget.Handle;
    // ʒm֐ۑ
    FOnDropped := AOnDropped;

    // 
    DropFileList := TStringList.Create;
    DropFoldList := TStringList.Create;
    DropPos      := Point(-1, -1);
    DropControl  := nil;
    // Ƃ肠
    FEnabled := False;
    // uWindowProcedureIuWFNg(MȂBȂ悤)
    FNewWndProc := Classes.MakeObjectInstance(WndProc);
    // uăIWiۑ
    FOldWndProc := Pointer(SetWindowLong(FWndHandle,GWL_WNDPROC,LongInt(FNewWndProc)));
end;

//------------------------------------------------------------------------------
(* fXgN^ *)
destructor  TShellDrop.Destroy;
begin
    if FEnabled then Stop();
    // ɖ߂
    SetWindowLong(FWndHandle, GWL_WNDPROC, LongInt(FOldWndProc));
    // XgJƂ
    DropFileList.Free;
    DropFoldList.Free;
    DropPos      := Point(-1, -1);
    DropControl  := nil;
    inherited;
end;

//------------------------------------------------------------------------------
(* C *)
procedure TShellDrop.WndProc(var Msg: TMessage);
var
    WMDropFiles: TWMDropFiles;
    i          : integer;
    FileName   : array [0..255] of Char;
    FileCount  : integer;
begin
    // hbvꂽ惁bZ[WL
    if (Msg.Msg = WM_DROPFILES) then
    begin
        // LXg
        WMDropFiles := TWMDropFiles(Msg);
        try
            //hbvʒu
            DragQueryPoint(WMDropFiles.Drop, DropPos);
            //hbvʒũRg[
            DropControl := FindDragTarget(FTarget.ClientToScreen(DropPos), False);
            //hbvt@C
            FileCount := DragQueryFile(WMDropFiles.Drop, $FFFFFFFF, FileName, SizeOf(FileName));
            //XgNA
            DropFileList.Clear;
            DropFoldList.Clear;
            // St@Cɑ΂
            for i := 0 to FileCount - 1 do
            begin
                // ǂȂH
                DragQueryFile(WmDropFiles.Drop, i, FileName, SizeOf(FileName));
                // t@CHtH_H
                UpdateDropList(FileName);
            end;
            // I
            DragFinish(WmDropFiles.Drop);
            // ʒm
            FOnDropped(DropFileList, DropFoldList, DropControl, DropPos);
        except
            // 蔭
            Application.HandleException(Self);
        end;
    end else
    begin
        // ̃bZ[W͒mBǂɂāB
        Msg.Result := CallWindowProc(FOldWndProc, FWndHandle, Msg.Msg, Msg.wParam, Msg.lParam);
    end;
end;

//------------------------------------------------------------------------------
(* 󂯕t *)
procedure   TShellDrop.Start();
begin
    if FEnabled then exit;
    DragAcceptFiles(FWndHandle, true);
    FEnabled := True;
end;

//------------------------------------------------------------------------------
(* 󂯕t܂ *)
procedure   TShellDrop.Stop();
begin
    if not FEnabled then exit;
    DragAcceptFiles(FWndHandle, False);
    FEnabled := False;
end;

end.
